<!-- 搜索表单 -->
<template>
  <el-form
    label-width="77px"
    class="ele-form-search"
    @keyup.enter.native="search"
    @submit.native.prevent
  >
    <el-row :gutter="15">
      <el-col v-bind="styleResponsive ? { lg: 5, md: 10 } : { span: 5 }">
        <el-form-item label="门店:">
          <ele-tree-select
            :data="groupsList"
            label-key="groupsName"
            value-key="groupsId"
            v-model="where.bizId"
            :clearable="true"
            placeholder="请选择"
            :disabled="false"
            :default-expand-all="false"
            :expand-on-click-node="false"
          />
        </el-form-item>
      </el-col>
      <el-col v-bind="styleResponsive ? { lg: 5, md: 10 } : { span: 5 }">
        <el-form-item label="商品:">
          <el-select
            clearable
            v-model="where.itemId"
            placeholder="请选择"
            class="ele-fluid"
          >
            <el-option
              v-for="item in goodsList"
              :key="item.itemId"
              :value="item.itemId"
              :label="item.title"
            />
          </el-select>
        </el-form-item>
      </el-col>
      <el-col v-bind="styleResponsive ? { lg: 5, md: 10 } : { span: 5 }">
        <el-form-item label="姓名:">
          <el-input clearable v-model="where.uname" placeholder="请输入" />
        </el-form-item>
      </el-col>
      <el-col v-bind="styleResponsive ? { lg: 5, md: 10 } : { span: 5 }">
        <el-form-item label="手机号:">
          <el-input clearable v-model="where.mobile" placeholder="请输入" />
        </el-form-item>
      </el-col>
      <el-col v-bind="styleResponsive ? { lg: 5, md: 10 } : { span: 5 }">
        <el-form-item label="中奖类型:">
          <el-select
            clearable
            v-model="where.winType"
            placeholder="请选择"
            class="ele-fluid"
          >
            <el-option
              v-for="item in winTypeList"
              :key="item.id"
              :value="item.id"
              :label="item.name"
            />
          </el-select>
        </el-form-item>
      </el-col>
      <el-col v-bind="styleResponsive ? { lg: 4, md: 8 } : { span: 4 }">
        <div class="ele-form-actions">
          <el-button
            type="primary"
            icon="el-icon-search"
            class="ele-btn-icon"
            @click="search"
          >
            查询
          </el-button>
          <el-button @click="reset">重置</el-button>
        </div>
      </el-col>
    </el-row>
  </el-form>
</template>

<script>
  import { listGroups } from '@/api/sylive/groups';
  import { listGoods } from '@/api/sylive/goods';
  import { getGroupsWinType } from '@/api/sylive/groups-win';

  export default {
    data() {
      // 默认表单数据
      const defaultWhere = {
        uname: '',
        mobile: '',
        winType: '',
        bizId: ''
      };
      return {
        activityId: null,
        // 门店数据
        groupsList: [],
        // 商品数据
        goodsList: [],
        winTypeList: [],
        // 表单数据
        where: { ...defaultWhere }
      };
    },
    computed: {
      // 是否开启响应式布局
      styleResponsive() {
        return this.$store.state.theme.styleResponsive;
      }
    },
    created() {
      this.groupsWinTypeQuery();
    },
    methods: {
      /* 搜索 */
      search() {
        this.$emit('search', this.where);
      },
      /*  重置 */
      reset() {
        this.where = { ...this.defaultWhere };
        this.search();
      },
      /* 查询中奖类型 */
      groupsWinTypeQuery() {
        getGroupsWinType({ activityId: this.activityId })
          .then((list) => {
            this.winTypeList = list;
          })
          .catch((e) => {
            this.$message.error(e.message);
          });
      },
      /* 查询分组 */
      groupsQuery() {
        listGroups({ activityId: this.activityId })
          .then((list) => {
            this.groupsList = this.$util.toTreeData({
              data: list,
              idField: 'groupsId',
              parentIdField: 'parentId'
            });
          })
          .catch((e) => {
            this.$message.error(e.message);
          });
      },
      /* 查询商品 */
      goodsQuery() {
        listGoods({ activityId: this.activityId })
          .then((list) => {
            this.goodsList = list;
          })
          .catch((e) => {
            this.$message.error(e.message);
          });
      }
    },
    watch: {
      $route: {
        handler(route) {
          const { path } = route;
          if (path !== '/sylive/groups-win') {
            return;
          }
          const activityId = this.$route.query.id;
          if (!activityId || activityId == this.activityId) {
            return;
          }
          this.activityId = activityId;
          if (this.$refs.table) {
            this.$refs.table.reload({ page: 1 });
          }
          this.groupsQuery();
          this.goodsQuery();
        },
        immediate: true
      }
    }
  };
</script>
